Option Explicit
Dim objFso

'==============================================================
' 摜TCYύX
'==============================================================
Sub resizeImage(input, output, intScaleRatio)
  Dim objImg
  Dim objIp
  
  input  = objFso.GetAbsolutePathName(input)
  output = objFso.GetAbsolutePathName(output)
  
  if objFso.FileExists(input) And Not objFso.FileExists(output) And Not objFso.FolderExists(output) And isImgFile(input) then

    Set objImg  = CreateObject("WIA.ImageFile")
    objImg.LoadFile(input)

    Set objIp  = CreateObject("WIA.ImageProcess")
    objIp.Filters.Add(objIp.FilterInfos("Scale").FilterID)
    objIp.Filters(1).Properties("MaximumWidth").Value = objImg.Width * (intScaleRatio/100)
    objIp.Filters(1).Properties("MaximumHeight").Value = objImg.Height * (intScaleRatio/100)
    Set objImg = objIp.Apply(objImg)

    objImg.SaveFile(objFso.GetAbsolutePathName(output))
      
  End if

  Set objImg = Nothing
  Set objIp = Nothing
End Sub

'==============================================================
' t@C^CvmF
'==============================================================
Function isImgFile(input)
  isImgFile=False
  
  If LCase(objFso.GetExtensionName(input)) = "png" Or _ 
     LCase(objFso.GetExtensionName(input)) = "jpg" Or LCase(objFso.GetExtensionName(input)) = "jpeg" Or _ 
     LCase(objFso.GetExtensionName(input)) = "gif" Or _
     LCase(objFso.GetExtensionName(input)) = "bmp" Then
    isImgFile=True
  End if
End Function

'==============================================================
' tH_̏ꍇ̏
'==============================================================
Sub ProcessingFolder(strTargetPath, strWorkDir, intScaleRatio)
  Dim intMsgRet
  Dim objFolder
  Dim objFile
  
  Set objFolder = objFso.GetFolder(strTargetPath)
  
  intMsgRet=MsgBox("hbOtH_ɂ摜t@Cgk܂B" & vbCrLf & _
                   "(TutH_͓WJ܂B)" ,  vbOKCancel,  "mF")
  If intMsgRet = 2 Then  '2:vbCancel
    Wscript.Quit()
  End If
  
  For Each objFile In objFolder.Files
    call resizeImage(strTargetPath & "\" & objFile.Name, strWorkDir & "\" & objFile.Name, intScaleRatio)
  Next
End Sub

'==============================================================
' t@C̏ꍇ̏
'==============================================================
Sub ProcessingFile(strTargetPath, strWorkDir, intScaleRatio)
  Dim intMsgRet
  Dim strFileName
    
  strFileName = objFso.GetFileName(strTargetPath)

  intMsgRet=MsgBox("hbOt@Cu" & strFileName & "vgk܂B" ,  vbOKCancel,  "mF")
  If intMsgRet = 2 Then  '2:vbCancel
    Wscript.Quit()
  End If
  
  call resizeImage(strTargetPath, strWorkDir & "\" & strFileName, intScaleRatio)
End Sub

'==============================================================
' Jn
'==============================================================
sub main
  Dim intScaleRatio
  Dim objArgs
  Dim strToolDir
  Dim strWorkDir
  Dim strTargetPath
  Dim isFile
  
  Set objFso = CreateObject( "Scripting.FileSystemObject" )

  strToolDir = objFso.getParentFolderName(WScript.ScriptFullName)
  strWorkDir = strToolDir & "\out"
  
  If objFso.FolderExists(strWorkDir) = False Then
    objFso.CreateFolder(strWorkDir)
  End If

  Set objArgs = WScript.Arguments
  If objArgs.Count <> 1 Then
    Call MsgBox("hbOt@ĆA1ł肢܂B" & vbCrLf & "FileCount = " & objArgs.Count )
    Wscript.Quit()
  End If

  strTargetPath = objArgs(0)
  If objFso.FileExists(strTargetPath) = True Then
    isFile=True
  Else
    isFile=False
  End If

  If Not isImgFile(strTargetPath) And isFile Then
    Call MsgBox("w̃t@ĆAł܂B")
    Wscript.Quit()
  End if

  intScaleRatio = InputBox("kڗIĂB" & vbCrLf & "(AXyNg͌ŒłB)" & vbCrLf & vbCrLf & _
                           "F50w肵ꍇ --" & vbCrLf & "  c/ꂼꂪ(50%)̒ɂȂ܂B"  & vbCrLf & _
                           "  t@CTCY1/3`1/4xɂȂ܂B" , "kڗݒ", "50")

  If IsEmpty(intScaleRatio) Or Not IsNumeric(intScaleRatio) then 
    Call MsgBox("LZ܂B")
    Wscript.Quit()
  End if
  
  If isFile Then
    Call ProcessingFile(strTargetPath, strWorkDir, intScaleRatio)
  Else
    Call ProcessingFolder(strTargetPath, strWorkDir, intScaleRatio)
  End If
  
  Wscript.Echo "I܂B"

  Set objFso = Nothing
End Sub

main
